/*	
 *	clippce.h
 *
 *	P/ECEp[`W߂܂B
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Wed Apr 24 09:26:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_PCE_H__
#define __CLIP_PCE_H__

/*****************************************************************************
 *	萔
 *****************************************************************************/

#define BLOCKSIZE	4096	/* tbṼZN^TCY */

#define PAD_MASK	0x00FF	/* PAD_A|B|START|SELECT */
#define TRG_MASK	0xFF00	/* TRG_A|B|START|SELECT */

/*****************************************************************************
 *	P/ECEpE[maint[[N
 *****************************************************************************/

/* AvP[V`̃Gg|CgłB
 * [out]
 *	߂l		IR[hB
 * [note]
 *	* AvP[VIɂ́Aʂ̕@܂B
 *	  1. main()ԂB
 *	  2. pceAppReqExit()Ă񂾌Ayield()ĂԁB
 */
int main();

/* VXeɐ܂B
 * [note]
 *	* AvP[V́AIyield()Ă΂Ȃ΂܂B
 */
void yield();

/* vOIɎs֐w肵܂B
 * [in]
 *	func		֐ւ̃|C^B
 * [out]
 *	߂l		o^ł0Ԃ܂B
 *			s0ȊO̒lԂ܂B
 * [note]
 *	* ݂̎ł́Ao^ł֐͈łB
 *	  Ȃ킿Aatexit()𕡐ĂԂƁAڈȍ~͎s܂B
 */
int atexit(void (*func )());

/*****************************************************************************
 *	[eBeBF^C}
 *****************************************************************************/

/* }CNbPʂ̎ԑ҂s܂B
 * [in]
 *	usec		҂[}CNb]
 * [note]
 *	* xJEgipceTimerAdjustPrecisionCount()j̒ĺA
 *	  16bit^C}̃JE^f[^ClockTicksl琶Ă܂B
 *	* ǂ̒l荞݋֎~JEgAbvp̂ŁA
 *	  荞݋֎~łusleep()gĎԑ҂sƂł܂B
 */
void usleep(unsigned long usec);

/*****************************************************************************
 *	[eBeBF`
 *****************************************************************************/

/* LCDCď܂B
 * [note]
 *	* ݂P/ECEJ[l(BIOS 1.18)ł́AAvP[VN邽тɁA
 *	  ʂ̔ZxoĂ܂Ƃ܂B
 *	* dAxłZbg{^ƁAZxo͂߂܂B
 *	* Zx̃ohɂ́ARESETB[qgLCDCď܂B
 *	  iP/ECEJ[ĺAResetR}hgĂ܂Ał̓_łj
 *	* ̊֐AAvP[VNɌĂяoĂB
 *	  RESETB[qgLCDCďAmɔZx̃oC܂B
 *	  gݍ݂pceAppInit()Ăяo悤ɂ܂B
 *	    AAvP[VvO璼ڌĂяoKv͂܂B
 *	* RESETBɂ郊ZbǵAOFFEVRAMNA𔺂̂ŁAӂB
 */
void lcd_init();

/* ݂̉zʂɁAIuWFNg`܂B
 * [in]
 *	src		]rbg}bvB
 *	dx,dy		]̍WB
 *	sx,sy		]̍WB
 *	w,h		]TCYB
 *	param		p[^B
 * [note]
 *	* pceLCDSetObject()/pceLCDDrawObject()̃yAĂяołB
 *	  ̈Ӗ́ApceLCDSetObject()ƓłB
 */
void draw_object(PIECE_BMP* src, int dx, int dy, int sx, int sy, int w, int h, int param);

/****************************************************************************
 *	[eBeBFt@C
 ****************************************************************************/

/* ZN^ɈˑȂAt@Cǂݍ݊֐łB
 * [in]
 *	fa		FILEACC\́B(FOMD_RDŊJĂ)
 *	ptr		obt@|C^B
 *	ofs		t@C擪̃oCgItZbgB
 *	len		ǂݍރoCgB
 * [out]
 *	߂l		ǂݍ񂾃oCgB
 *			ǂݍ݂Ɏs0Ԃ܂B
 * [note]
 *	* ZN^E܂œǂݍނƂł܂B
 */
int file_read(FILEACC* fa, void* ptr, int ofs, int len);

/* ZN^ɈˑȂAt@C݊֐łB
 * [in]
 *	fa		FILEACC\́B(FOMD_WRŊJĂ)
 *	ptr		obt@|C^B
 *	ofs		t@C擪̃oCgItZbgB
 *	len		ރoCgB
 * [out]
 *	߂l		񂾃oCgB
 *			݂Ɏs0Ԃ܂B
 * [note]
 *	* ZN^E܂ŏނƂł܂B
 *	* ̃t@CêA܂Ȃ͕ωA̓eێ܂B
 *	  pceFileWriteSct()gꍇ́AZN^̏܂Ȃ͏܂B
 */
int file_write(FILEACC* fa, const void* ptr, int ofs, int len);

/* t@CɊ܂܂鈳kf[^WJ܂B
 * [in]
 *	fa		FILEACC\́B(FOMD_RDŊJĂ)
 *	outbuf		WJobt@B
 *	outlen		WJobt@TCYB
 *	inofs		kf[^̐擪ItZbgB
 *	inlen		kf[^̃oCgB
 *			0w肷ƁAinofst@CI[܂łƌȂ܂B
 * [out]
 *	߂l		WJ̃oCgB
 *			WJɎs0Ԃ܂B
 */
int file_inflate(FILEACC* fa, void* outbuf, int outlen, int inofs, int inlen);

/* t@CɊ܂܂鈳kf[^̓WJTCY𒲂ׂ܂B
 * [in]
 *	fa		FILEACC\́B(FOMD_RDŊJĂ)
 *	inofs		kf[^̐擪ItZbgB
 *	inlen		kf[^̃oCgB
 *			0w肷ƁAinofst@CI[܂łƌȂ܂B
 * [out]
 *	߂l		WJ̃oCgB
 *			WJɎs0Ԃ܂B
 */
int file_inflate_size(FILEACC* fa, int inofs, int inlen);

/* t@CpbNt@CT܂B
 * [in]
 *	fa		FILEACC\́B(FOMD_RDŊJĂ)
 *	fnmame		t@CB
 * [out]
 *	߂l		t@Cւ̃|C^Ԃ܂B
 *			ȂNULLԂ܂B
 * [note]
 *	* ̊֐Ԃt@Cւ̃|C^́A
 *	  ֐staticϐ̈wĂ܂B
 *	  Å֐Ă񂾂Ƃɔj󂳂܂̂ŁA
 *	  KvȂΌĂяoŃRs[ĂB
 */
FILE_INFO* fpak_find(FILEACC* fa, const char* fname);

/* t@CpbNɊ܂܂鈳kf[^WJ܂B
 * [in]
 *	fa		FILEACC\́B(FOMD_RDŊJĂ)
 *	outbuf		WJobt@B
 *	outlen		WJobt@TCYB
 *	fname		t@CB
 * [out]
 *	߂l		WJ̃oCgB
 *			WJɎs0Ԃ܂B
 */
int fpak_inflate(FILEACC* fa, void* outbuf, int outlen, const char* fname);

/* t@CpbNɊ܂܂鈳kf[^̓WJTCY𒲂ׂ܂B
 * [in]
 *	fa		FILEACC\́B(FOMD_RDŊJĂ)
 *	fname		t@CB
 * [out]
 *	߂l		WJ̃oCgB
 *			WJɎs0Ԃ܂B
 */
int fpak_inflate_size(FILEACC* fa, const char* fname);

/****************************************************************************
 *	[eBeBFGSM
 ****************************************************************************/

/* GSMt@CĐJn܂B
 * [in]
 *	ch		Đ`lB(0`3)
 *	fname		GSMt@CB
 *	loop		[v񐔁B(-1:,0:ĐȂ,1`:[v)
 * [out]
 *	߂l		ĐJnł0Ԃ܂B
 *			s-1Ԃ܂B(t@CȂA)
 */
int gsm_play(int ch, const char* fname, int loop);

/* GSMt@C̍Đ~܂B
 * [note]
 *	* ĐłȂ΁Å֐͉܂B
 */
void gsm_stop();

#endif /*__CLIP_PCE_H__*/
