/*	
 *	app.h
 *
 *	lotlot - bgbgǂ
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Wed Jul 17 05:13:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __APP_H__
#define __APP_H__

#include <clip.h>

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS	20			/* t[[g   */
#define SEC(s)	((int)(FPS * (s)))	/* b->t[ϊ */

/*      === ʃCAEg ===     
   00000000001111111111222222222233
   01234567890123456789012345678901
  +--------------------------------+
00| #                       #      |
01| #                       #      |
02| #-----+-----+-----+-----+      |
03| #     |     |     |     |      |
04| #     |     |     |     |      |
05| #     |     |     |     |      |
06| #-----+-----+-----+-----+      |
07| #     |     |     |     |      |
08| #     |     |     |     |      |
09| #     |     |     |     |      |
10| #-----+-----+-----+-----+      |
11| #     |     |     |     |      |
12| #     |     |     |     |      |
13| #     |     |     |     |      |
14| #-----+-----+-----+-----+      |
15| #     |     |     |     |      |
16| #     |     |     |     |      |
17| #     |     |     |     |      |
18| #.....+-----+-----+-----+      |
19|                                |
20| #     #     #     #     #     #|
21| #     #     #     #     #     #|
  +--------------------------------+
*/

#define COLS	(DISP_X / 4)	/* ʑŜ̗ */
#define ROWS	(DISP_Y / 4)	/*           s */

/* ubNzu */
typedef struct _BLOCK {
	unsigned char x, y;	/* ̍W */
	unsigned char len;	/* ѐ     */
	unsigned char dir;	/* 0:/1:c  */
} BLOCK;
/* ŒubN */
BLOCK fixblks[] = {
	{ 1, 0,19,1},                                       {25, 0, 2,1},
	{ 1,20, 2,1},{ 7,20, 2,1},{13,20, 2,1},{19,20, 2,1},{25,20, 2,1},{31,20, 2,1},
};
#define N_FIXBLKS	(sizeof fixblks / sizeof *fixblks)
/* fbhC */
BLOCK linblks[] = {
	{ 2,18, 5,0},
};
#define N_LINBLKS	(sizeof linblks / sizeof *linblks)
/* ubN */
BLOCK actblks[] = {
	/*  */
	{ 7, 2, 1,0},{13, 2, 1,0},{19, 2, 1,0},{25, 2, 1,0},
	{ 7, 6, 1,0},{13, 6, 1,0},{19, 6, 1,0},{25, 6, 1,0},
	{ 7,10, 1,0},{13,10, 1,0},{19,10, 1,0},{25,10, 1,0},
	{ 7,14, 1,0},{13,14, 1,0},{19,14, 1,0},{25,14, 1,0},
	{ 7,18, 1,0},{13,18, 1,0},{19,18, 1,0},{25,18, 1,0},
	/*  */
	{ 2, 2, 5,0},{ 8, 2, 5,0},{14, 2, 5,0},{20, 2, 5,0},
	{ 2, 6, 5,0},{ 8, 6, 5,0},{14, 6, 5,0},{20, 6, 5,0},
	{ 2,10, 5,0},{ 8,10, 5,0},{14,10, 5,0},{20,10, 5,0},
	{ 2,14, 5,0},{ 8,14, 5,0},{14,14, 5,0},{20,14, 5,0},
	             { 8,18, 5,0},{14,18, 5,0},{20,18, 5,0},
	/* c */
	{ 7, 3, 3,1},{13, 3, 3,1},{19, 3, 3,1},{25, 3, 3,1},
	{ 7, 7, 3,1},{13, 7, 3,1},{19, 7, 3,1},{25, 7, 3,1},
	{ 7,11, 3,1},{13,11, 3,1},{19,11, 3,1},{25,11, 3,1},
	{ 7,15, 3,1},{13,15, 3,1},{19,15, 3,1},{25,15, 3,1},
};
#define N_ACTBLKS	(sizeof actblks / sizeof *actblks)

/* tB[hEZ萔 (ŏʃrbg0Ȃʂ܂) */
#define CEL_NULSPC	0x00		/* kXy[X */
#define CEL_OPNBLK	0x01		/* JubN */
#define CEL_FIXBLK	0x80		/* ŒubN */
#define CEL_LINBLK	0x81		/* fbhC */
#define CEL_CLSBLK	0x82		/* ubN */
#define CEL_BALLDN	0x83		/* ړ{[ */
#define CEL_BALLLF	0x84		/* ړ{[ */
#define CEL_BALLRI	0x85		/* Eړ{[ */

/* rbg}bv̐؏o (x,y,w,h ̕) */
#define CHR_NULSPC	 0,0,0,0	/* kXy[X */
#define CHR_FIXBLK	 4,0,4,4	/* ŒubN */
#define CHR_LINBLK	 8,0,4,4	/* fbhC */
#define CHR_CLSBLK	12,0,4,4	/* ubN */
#define CHR_OPNBLK	16,0,4,4	/* JubN */

/****************************************************************************
 *	ϐ錾
 ****************************************************************************/

#include "work.h"

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
int demo();
void game();
void wipeout();

#endif /*__APP_H__*/
